Last updated

API / geotoolkit / map / sources / GeoJSON / GeoJSON

Class: GeoJSON

sources.GeoJSON.GeoJSON

Vector source that allows user to get features from remote resource in GeoJSON format

Hierarchy

Table of contents

Constructors
Methods
Css Properties
Name Type Description
systemstringInitial data coordinate system
urlstringData server url

Contents

Constructors

new GeoJSON(options)

new GeoJSON(options?)

Parameters

Name Type Description
Optional optionsOptionsoptions

Overrides

Vector.constructor

Methods

addFeatures

addFeatures(features, needTransform?): GeoJSON

Notifies source to add features.

Parameters

Name Type Description
featuresAbstractFeature[]features to add
Optional needTransformbooleantrue if features should be transformed to the map coordinates

Returns

GeoJSON

this

Inherited from

Vector.addFeatures


clear

clear(): GeoJSON

Clears all the data.

Returns

GeoJSON

this

Inherited from

Vector.clear


clearFeatures

clearFeatures(): GeoJSON

Notifies source to remove all features added.

Returns

GeoJSON

this

Inherited from

Vector.clearFeatures


dispose

dispose(): void

Disposes this source, once disposed it should not be used anymore.

Returns

void

Inherited from

Vector.dispose


getClassName

getClassName(): string

Returns

string

Inherited from

Vector.getClassName


getCopyright

getCopyright(): string

Returns copyright information.

Returns

string

Inherited from

Vector.getCopyright


getDataLoader

Protected getDataLoader(): AbstractLoader

Returns server data loader (if exists)

Returns

AbstractLoader

Inherited from

Vector.getDataLoader


getInitialCoordinateSystem

getInitialCoordinateSystem(): AbstractSystem

Gets current data initial coordinate system.

Returns

AbstractSystem

Inherited from

Vector.getInitialCoordinateSystem


getMapCoordinateSystem

getMapCoordinateSystem(): AbstractSystem

Gets current map coordinate system.

Returns

AbstractSystem

Inherited from

Vector.getMapCoordinateSystem


getModelLimits

getModelLimits(): Rect

Returns the current data model limits (presumably loaded from the server if it's settled)

Returns

Rect

Inherited from

Vector.getModelLimits


getProperties

getProperties(): OptionsOut

Returns properties

Returns

OptionsOut

properties

Inherited from

Vector.getProperties


getRequestResolution

getRequestResolution(): number

Gets the grid size for layer partitioning that is used for server requests

Returns

number

Inherited from

Vector.getRequestResolution


getServerData

getServerData(): JSONObject | XMLDocument

Returns server data loaded from the server Should be used asynchronically after loadServerData() method is called

Returns

JSONObject | XMLDocument

Inherited from

Vector.getServerData


getServerURL

getServerURL(): string | string[]

Gets the server url that is currently used for requests

Returns

string | string[]

server url

Inherited from

Vector.getServerURL


getTransformerFromMap

getTransformerFromMap(): Transformer

Gets transformer to transform data from map coordinate system

Returns

Transformer

Inherited from

Vector.getTransformerFromMap


getTransformerToMap

getTransformerToMap(): Transformer

Gets transformer to transform data to map coordinate system

Returns

Transformer

Inherited from

Vector.getTransformerToMap


getUniqueField

getUniqueField(): string

Gets the unique identifier for the dataset

Returns

string

field

Inherited from

Vector.getUniqueField


hasEventListener

hasEventListener(type, callback?): boolean

Check if a list of event listeners for this type contains this listener

Parameters

Name Type Description
typestringtype of event or property
Optional callbackFunctionto be called, if null, check if any callback is registered

Returns

boolean

Inherited from

Vector.hasEventListener


initLoader

Protected initLoader(loader?): GeoJSON

Initializes the loader provided

Parameters

Name Type Description
Optional loaderAbstractLoaderloader to use

Returns

GeoJSON

this

Inherited from

Vector.initLoader


isDataLoaded

isDataLoaded(): boolean

Returns true if server data is already loaded (or no loader provided)

Returns

boolean

Inherited from

Vector.isDataLoaded


isDataReady

isDataReady(): boolean

Checks if source (current visible) data is loaded and ready to be rendered

Returns

boolean

Inherited from

Vector.isDataReady


isDisposed

isDisposed(): boolean

Returns whether this object has been disposed

Returns

boolean

Inherited from

Vector.isDisposed


isLoading

isLoading(): boolean

Checks if some of the requests haven't been finished yet. Returns true if some data is loading, false otherwise.

Returns

boolean

Inherited from

Vector.isLoading


isSilent

isSilent(): boolean

Return true if the event dispatcher doesn't notify any events

Returns

boolean

Inherited from

Vector.isSilent


loadServerData

loadServerData(): Promise<GeoJSON>

Returns promise that is loaded when server settings are ready to process

Returns

Promise<GeoJSON>

Inherited from

Vector.loadServerData


loadSourceData

loadSourceData(): Promise<AbstractSource>

Returns promise that is resolving when data are ready to process

Returns

Promise<AbstractSource>

Inherited from

Vector.loadSourceData


notify

notify<E>(type, source, args?): GeoJSON

Notify listeners

Type parameters

NameType
Eextends string

Parameters

Name Type Description
typeEevent types
sourceVectorof the event
Optional argsEventMap[E]arguments of the event

Returns

GeoJSON

this

Inherited from

Vector.notify


off

off<E>(type?, callback?): GeoJSON

Detach listener on event. Calling .off() with no arguments removes all attached listeners. Calling .off(type) with no callback removes all attached listeners for specific type.

Type parameters

NameType
Eextends string

Parameters

Name Type Description
Optional typeEtype of the event
Optional callback(eventType: E, sender: GeoJSON, args: EventMap[E]) => voidfunction to be called

Returns

GeoJSON

this

Inherited from

Vector.off


on

on<E>(type, callback): GeoJSON

Attach listener on event that will be called whenever the specified event is delivered to the target

If the callback function is already in the list of event listeners for this target, the function is not added a second time.

If a particular anonymous function is in the list of event listeners registered for a certain target, and then later in the code, an identical anonymous function is given in an "on" call, the second function will also be added to the list of event listeners for that target.

Type parameters

NameType
Eextends string

Parameters

Name Type Description
typeEtype of event or property
callback(eventType: E, sender: GeoJSON, args: EventMap[E]) => voidto be called

Returns

GeoJSON

this

Inherited from

Vector.on


queryFeatures

queryFeatures(bbox, layer): GeoJSON

Sends a request for features in given bounding box.

Parameters

Name Type Description
bboxRectbounding box for features
layerAbstractFeatureLayerlayer requesting

Returns

GeoJSON

this

Inherited from

Vector.queryFeatures


removeFeature

removeFeature(feature): GeoJSON

Notifies source to remove feature.

Parameters

Name Type Description
featureAbstractFeaturefeature to remove

Returns

GeoJSON

this

Inherited from

Vector.removeFeature


requestData

requestData(resource): void

Requests data from the resource and parses the response

Parameters

Name Type Description
resourcestringresource url for request

Returns

void

Inherited from

Vector.requestData


resetLastQueryParams

Protected resetLastQueryParams(): GeoJSON

Resets saved last queried limits and layer

Returns

GeoJSON

this

Inherited from

Vector.resetLastQueryParams


setDataReady

Protected setDataReady(isReady, err?): GeoJSON

Sets source (current visible) data ready/not ready, changes the corresponding promise

Parameters

Name Type Description
isReadybooleantrue if source data was loaded, false if it needs to be reset
Optional errErrordata loading error (if exists)

Returns

GeoJSON

this

Inherited from

Vector.setDataReady


setInitialCoordinateSystem

setInitialCoordinateSystem(system): GeoJSON

Sets the data initial coordinate system.

Parameters

Name Type Description
systemstring | AbstractSysteminitial coordinate system

Returns

GeoJSON

this

Inherited from

Vector.setInitialCoordinateSystem


setMapCoordinateSystem

setMapCoordinateSystem(system): GeoJSON

Sets map coordinate system.

Parameters

Name Type Description
systemstring | AbstractSystemmap coordinate system

Returns

GeoJSON

this

Inherited from

Vector.setMapCoordinateSystem


setProperties

setProperties(properties?): GeoJSON

Sets properties

Parameters

Name Type Description
Optional propertiesOptionsproperties

Returns

GeoJSON

this

Inherited from

Vector.setProperties


setQueryParameter

setQueryParameter(param, value?): GeoJSON

Sets custom query parameter to add to the data requests

Parameters

Name Type Description
paramstring | Record<string, string | number>parameter name or custom parameters object (in name -> value format)
Optional valuestring | numberparameter value

Returns

GeoJSON

this

Inherited from

Vector.setQueryParameter


setRequestResolution

setRequestResolution(resolution): GeoJSON

Sets the grid size for layer partitioning that is used for server requests

Parameters

Name Type Description
resolutionnumbergrid size

Returns

GeoJSON

this

Inherited from

Vector.setRequestResolution


setServerURL

setServerURL(url): GeoJSON

Sets the server url to use for requesting

Parameters

Name Type Description
urlstring | string[]server url

Returns

GeoJSON

this

Inherited from

Vector.setServerURL


setSilent

setSilent(bool): GeoJSON

Set silent mode

Parameters

Name Type Description
boolbooleanflag to enable silent mode

Returns

GeoJSON

this

Inherited from

Vector.setSilent


setUniqueField

setUniqueField(field): GeoJSON

Sets the unique identifier for the features

Parameters

Name Type Description
fieldstringunique identifier

Returns

GeoJSON

this

Inherited from

Vector.setUniqueField


update

update(): GeoJSON

Aborts all the sent requests, resends the last one

Returns

GeoJSON

this

Inherited from

Vector.update


getClassName

Static getClassName(): string

Returns

string

Inherited from

Vector.getClassName